Subject: bug#49247: 28.0.50; [Feature Request] Make tab-bar-lines dragable

From: Juri Linkov <[email-masked]>
Date: Thu, 08 Jul 2021 01:54:10 +0300

>> Why buffer's mode keymap affects the behavior of clicking
>> on the tab-line?
> [...]
>> The difference is that in the broken case it says:
>>
>>    "Those are influenced by `mouse-1-click-follows-link'"
>>
>> and translates <mouse-1> to <mouse-2>, where <mouse-2> is a valid
>> binding that closes the tab.  But translating <mouse-1> to <mouse-2>
>> is a bug, I don't know how to fix it.
>
> It might happen in `mouse--click-1-maybe-follows-link' but that is
> written in terms of `pcase' which I cannot read fluently.  Honestly,
> key translations are a mystery to me.
>
> I see two possibilities to fix this without further hassle.  Either I
> revert my changes

Please don't revert your changes: 'drag-with-tab-line' is a valid feature.

> or you give up on binding mouse-1 and mouse-2 to different actions.

I can't give up on binding mouse-2 to closing the tab
because this is what browsers do where mouse-2 closes the tab.

> I think that the mouse-2 binding at hand is not
> useful because not all people can use it reliably (for example here the
> scroll wheel may always slip slightly before pressing it) and all your
> remaining keymaps bind mouse-1 and mouse-2 to the same action.

Drew suggested to make an exception for the tab-bar.
This could solve the problem when the exception
will be added somewhere in mouse--click-1-maybe-follows-link.

> BTW, I think that the mouse wheel should scroll the tab-line,
> if applicable.

The mouse wheel already scrolls the tab-line when it's long enough.